@building-option +create-set-co
@create #2255 named XMPP IQ vCard:XMPP IQ vCard,iqvcard
;_.("key") = 0
;_.("aliases") = {"XMPP IQ vCard", "iqvcard"}
;_.("offered") = #-1
;_.("object_size") = {1874, 1188374415}
;_.("review_marks") = {}
"_.("review_history") => E_PERM (Permission denied)

@verb _:":handle" this none this
@program _::handle
{children, origin} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
feature = $local.jabber.feature;
if (valid(target = feature:is_user(origin.to)))
  if (validsource = feature:_buddy_in_roster(target, origin.from))
    iq = $local.jabber:new_type_handler("iq");
    iq.to = origin.from;
    iq.from = origin.to;
    iq.id = origin.id;
    iq.type = "result";
    vCard = iq:add_entity("vCard");
    vCard:add_attribute(@children[1][2][1]);
    nickname = vCard:add_entity("NICKNAME");
    nickname.data = target:namec();
    if (avatar = feature.options:get(feature:get_jabber_options(target), "avatar"))
      photo = vCard:add_entity("PHOTO");
      type = photo:add_entity("TYPE");
      type.data = avatar[3];
      binval = photo:add_entity("BINVAL");
      binval.data = avatar[4];
    endif
    $local.jabber:send(iq);
    return 1;
  endif
endif
.

"***finished***
