@building-option +create-set-co
@create #1900 named XMPP message:XMPP message,Jabber message,jmsg
@prop _."stanza" "message" rc
@prop _.":type" "" ""
@prop _.":body" "" ""
;_.("key") = 0
;_.("aliases") = {"XMPP message", "Jabber message", "jmsg"}
;_.("offered") = #-1
;_.("object_size") = {3349, 1188374415}
;_.("review_marks") = {}
"_.("review_history") => E_PERM (Permission denied)

@verb _:":handle" this none this
@program _::handle
{connection, type, attributes, text, children} = args;
error = 0;
for attribute in (attributes)
  {key, value} = attribute;
  if (key == "to")
    if (index(value, "@") > 1)
      target = value[1..index(value, "@") - 1];
      if (!valid(target = $local.jabber.feature:is_user(target)))
        error = "no such user";
      endif
    else
      error = "no such user";
    endif
  elseif (key == "from")
    source = value;
  elseif (key == "type")
    type = value;
  endif
endfor
if ((!error) && source)
  msg = `this:mine_tag((type == "error") ? "error" | "body", children) ! E_NONE';
  if (msg != E_NONE)
    $local.jabber.feature:receive_message(target, source, msg, type);
  endif
endif
return 1;
.

@verb _:":mine_tag" this none this
@program _::mine_tag
{tag, children} = args;
for child in (children)
  if (child[1] == tag)
    return child[3];
  endif
endfor
raise(E_NONE);
.

@verb _:":serialize" this none this
@program _::serialize
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
xml = {this.class.stanza, {{"type", this.type}, {"to", this.to}, {"from", this.from}}, "", {}};
if (mybody = this.body)
  xml[4] = {@xml[4], {"body", {}, mybody, {}}};
endif
return $local.xml:xml_unparse(@xml);
.

@verb _:":failure" this none this
@program _::failure
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (this.type != "error")
  from = this.from;
  this.from = this.to;
  this.to = from;
  this.type = "error";
  $local.jabber:send(this);
endif
.

"***finished***
