@building-option +create-set-co
@create #1900 named XMPP presence:XMPP presence,Jabber presence,xmpp-presence
@prop _."stanza" "presence" rc
@prop _.":show" "" rc
@prop _.":type" "" rc
@prop _.":status" "" ""
;_.("key") = 0
;_.("aliases") = {"XMPP presence", "Jabber presence", "xmpp-presence"}
;_.("offered") = #-1
;_.("object_size") = {2823, 1188374415}
;_.("review_marks") = {}
"_.("review_history") => E_PERM (Permission denied)

@verb _:":handle" this none this
@program _::handle
{connection, type, attributes, text, children} = args;
error = "";
presence = "online";
for attribute in (attributes)
  {key, value} = attribute;
  if (key == "to")
    target = value[1..index(value, "@") - 1];
    if (!valid(target = $local.jabber.feature:is_user(target)))
      error = "no such user";
    endif
  elseif (key == "from")
    source = value;
  elseif (key == "type")
    presence = value;
  endif
endfor
if (!error)
  show = this:mine_tag("show", children);
  status = this:mine_tag("status", children);
  $local.jabber.feature:receive_presence(target, source, presence, show, status);
endif
.

@verb _:":serialize" this none this
@program _::serialize
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
xml = {"presence", {{"from", this.from}, {"to", this.to}}, "", {}};
if (this.type)
  xml[2] = {@xml[2], {"type", this.type}};
endif
for child in ({"show", "status"})
  if (this.(child))
    xml[4] = {@xml[4], {child, {}, this.(child), {}}};
  endif
endfor
for child in (this.children)
  xml[4] = {@xml[4], child:serialize(0)};
endfor
return $local.xml:xml_unparse(@xml);
.

@verb _:":mine_tag" this none this
@program _::mine_tag
{tag, children} = args;
for child in (children)
  if (child[1] == tag)
    return child[3];
  endif
endfor
return "";
.

"***finished***
