@building-option +create-set-co
@create #1900 named XMPP stream:XMPP stream,Jabber stream,jstream
@prop _.":local_id" "" ""
@prop _.":remote_id" "" ""
@prop _.":xmlns" "jabber:server" ""
@prop _.":xmlns_stream" "http://etherx.jabber.org/streams" ""
@prop _.":xmlns_db" "jabber:server:dialback" ""
@prop _.":id_remote" "" ""
@prop _.":id" "" ""
@prop _.":established" 0 ""
@prop _.":connection" #-1 ""
@prop _."stanza" "stream" rc
;_.("key") = 0
;_.("aliases") = {"XMPP stream", "Jabber stream", "jstream"}
;_.("offered") = #-1
;_.("object_size") = {5326, 1188374415}
;_.("review_marks") = {}
"_.("review_history") => E_PERM (Permission denied)

@verb _:":serialize" this none this
@program _::serialize
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (this.connection.outbound)
  stream = {"stream:stream", {{"xmlns:stream", "http://etherx.jabber.org/streams"}, {"xmlns", "jabber:server"}, {"to", this.to}, {"id", this.id}, {"xmlns:db", "jabber:server:dialback"}}, "CUT-HERE!", {}};
else
  stream = {"stream:stream", {{"xmlns:stream", this.xmlns_stream}, {"xmlns", this.xmlns}, {"id", this.id}, {"xmlns:db", this.xmlns_db}}, "CUT-HERE!", {}};
  if (this.from)
    stream[2] = listinsert(stream[2], {"from", this.from}, 3);
  endif
endif
reply = tostr("<?xml version='1.0'?>", $local.xml:xml_unparse(@stream));
reply = reply[1..index(reply, "CUT-HERE!") - 1];
return reply;
.

@verb _:":set_many" this none this
@program _::set_many
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
for keydata in (args)
  {prop, value} = keydata;
  prop = strsub(prop, ":", "_");
  if (prop == "id")
    prop = "id_remote";
  elseif (prop == "to")
    prop = "from";
  elseif (prop == "from")
    prop = "to";
  endif
  `this.prop = value ! E_PROPNF => 0';
endfor
.

@verb _:":generate_id" this none this
@program _::generate_id
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
randomized = tostr(time(), random());
new_id = string_hash(tostr(randomized, this.id_remote));
return this.id = new_id;
.

@verb _:":initialize" this none this
@program _::initialize
if ((caller == this) || $perm_utils:controls(caller_perms(), this))
  this:generate_id();
endif
return pass(@args);
.

@verb _:":set_connected" this none this
@program _::set_connected
{state} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
this.established = state;
$local.jabber:run_dequeuer();
return this.established;
.

@verb _:":connected" this none this
@program _::connected
{?target = 1} = args;
if ((!(caller in {this, this.connection})) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
return this.established >= target;
.

@verb _:":handle" this none this
@program _::handle
{connection, type, attributes, text, children} = args;
subtype = type[index(type, ":") + 1..$];
if (subtype == "error")
  this.connection:report_traceback(text);
endif
.

"***finished***
